
<h4 align="center"> <sup> Please Install <a href="https://www.curseforge.com/minecraft/mc-mods/ftb-quests-fabric"> FTB Quests | </a> <a href="https://www.curseforge.com/minecraft/mc-mods/ftb-teams-fabric"> FTB Teams | </a> <a href="https://www.curseforge.com/minecraft/mc-mods/ftb-library-fabric"> FTB Library | </a> <a href="https://www.curseforge.com/minecraft/mc-mods/quests-additions-fabric"> Quest Additions </a> Manually! </sup> <br> </br> </h4>

<h4 align="center"> <sup> Please check <a href="https://github.com/DM-Earth/Cabricality/wiki"> Cabricality Wiki </a> when you have any problems.</sup></h4>

<div align="center"> <img src="https://github.com/DM-Earth/Cabricality/blob/packwiz/1.18.2/quilt/dev/assets/cabricality_banner.png?raw=true" width = 495 alt="Cabricality"> </div>
<h1 align="center"> Cabricality </h1>

**Cabricality is a *Create centered* challengable Minecraft Modpack for *Quilt 1.18.2.***

With this pack, you can follow the quests and build your own factory with [Create](https://github.com/Fabricators-of-Create/Create) and [Industrial Revolution](https://github.com/GabrielOlvH/Industrial-Revolution). From shoveling clays under valleys to voyaging inside space stations, you can develop the technologies diversely as you want.

> *This modpack is inspired by [Create: Above and Beyond (CAB),](https://github.com/simibubi/Above-and-Beyond) but reimplemented on the base of the original pack. Welcome, challenger, we hope you to enjoy our work!*

<h3 align="center"> English | <a href="docs/readme/zh_cn.md"> 简体中文 </a> </h3>

## Features

### Thread Basing

As a technical modpack, Cabricality has a **main thread** of technology developments. Aside from it, there are **sub threads** of unnecessary technologies.

The **well-described** quests will surely set you up goals before every tech term. Don't worry, with us, you will be neither stressed out nor puzzled.

### Quest Helpers

Lying on the left of the quest page, `Overview` is where you can unlock and review all the **chapters** and **milestones** at a glance. Every chapter has its unique assembly lines, and brand-new adventures.

Well, quests are just helpful tools we have prepared for you. It's absolutely at your will to choose to experience the pack in your own way!

### Automata Era

Nearly all machine necessities are **automatable.** It may be painful to reasonably divide the occupied area and functions of machinery, but as the old saying goes, no pains no gains. After all, you'll be able to unlock milestones and have encompassing visions of your magnificent factory!

### Trading Wonders

You will have the ability to produce **trade stations** when brass supply is sufficient. When you plug the precise instrument on with adequate energy, it roars. With the help of `trade cards` and `profession cards`, some rarely seen materials could be exchanged by coins, and the process can also **be reversed.** Ah, my precious!

The system is poorly needed during the produce of `enderium` materials. The queer material born in anotherland, combines silver coins in a mysterious way. If you aren't an alchemist, the only way to obtain them is through trade.

### Chaotic Alchemies

Substrates caged in glass jars break into pieces of treasure at the presence of an alchemist. You can do it too! Infuse dusts to molten glass yields substrates, and after mixing and smelting and the help of catalysts, **matters manufacture matters.** It's magic!

Catalysts aren't that easy to obtain. Struct a **laser emitter** and let the particle ray combine right substrates into exact catalysts. The recipe is randomly different between worlds, so excite yourself to find the right ones!

### Space Exploring

You might leave behind quests by landing on the moon, but your story never ends. **Ad Astra!** made exploring other planets and galaxies possible, what's more, you can build your space stations outside atmospheres!

*Deeper adventure awaits, don't stop, Hitch Hiker!*

## Optimizing

We prefer you to optimize your games on your own.

**If you want a higher FPS(Frames per second),** vsync may help. **When the TPS(Ticks per second) is badly low,** try to enter a new world in `Creative Mode` before you switch to other modes you like.

If you like to write scripts and add your favorites to the game, **you're welcome!**

## Technical Assistances

**All development details can be found in this GitHub repository. You can follow this project by watching it.**

This modpack is managed and developed using [packwiz](https://github.com/packwiz/packwiz) and released using [Modrinth format pack.](https://docs.modrinth.com/docs/modpacks/format_definition)

### Build from Sources

Clone this repository and download [packwiz](https://github.com/packwiz/packwiz) to the pack's root dictionary, then run the commands below:

**macOS / Linux:**

```
./packwiz modrinth export
```

**Windows:**

```
packwiz modrinth export
```

**If you want to export a CurseForge format pack, you can use command below[^curseforge]:**

```
packwiz curseforge export
```

[^curseforge]: It's not recommended because all mods were imported from Modrinth.

> *For more information, see [packwiz wiki.](https://packwiz.infra.link)*

### Supported Launchers

We support almost all launchers that compatible with **Modrinth format pack** and **Quilt.** Such as [MultiMC,](https://github.com/MultiMC/Launcher) [PolyMC](https://github.com/PolyMC/PolyMC) and [Hello Minecraft! Launcher](https://github.com/huanghongxun/HMCL)[^pcl2].

[^pcl2]: **Note that [PCL2 Launcher](https://github.com/Hex-Dragon/PCL2) is not compatible.**

### Licence

This project is licenced under **AGPL-3.0.**
